//
//  Sorts.swift
//  Swiftement Pokemon
//
//  Created by Onoulade on 15/01/2022.
//

import Foundation

/*
 La classe sort qui se conforme au protocole de capacité
 */

class Sort: Capacite {
    
    var nom: String
    var element: Element? = nil
    var recharges: Int
    var vieRestauree: Int = 0
    var defenseEnnemieDiminuee: Int = 0
    var rechargesMax: Int
    
    // On chaque sort peut soigner et diminuer la défense de l'ennemi, voire les deux
    init(nom: String, recharges: Int, vieRestauree: Int = 0, defenseEnnemieDiminuee: Int = 0) {
        self.nom = nom
        self.recharges = recharges
        self.vieRestauree = vieRestauree
        self.defenseEnnemieDiminuee = defenseEnnemieDiminuee
        self.rechargesMax = recharges
    }
    
    // Même principe qu'avec attaque, on utilise le sort d'un pokémon sur un autre
    func utiliser(avec joueur: Pokemon, sur ennemi: Pokemon) -> Bool {
        if recharges == 0 {
            print("Le sort ", nom, " n'a plus de recharges !")
            return false
        }
        
        // On effectue les actions relatives au sort en fonction des valeurs attribuées,
        // on suppose que si elles sont à 0 alors le sort n'a pas à effectuer cet effet
        if vieRestauree > 0 {
            print(joueur.nom, "utilise", nom)
            joueur.gagne(pointsVie: vieRestauree)
        }
        if defenseEnnemieDiminuee > 0 {
            print(joueur.nom, "utilise", nom, "sur", ennemi.nom)
            ennemi.subit(pointsDefense: defenseEnnemieDiminuee)
        }
        
        // Et on oublie pas de décompter les utilisations
        self.recharges -= 1
        return true
    }
    
    // Les initaliseurs de tous les sorts en mode statique
    
    static var soin: Sort {
        get {
            return .init(nom: "Soin", recharges: 3, vieRestauree: 5)
        }
    }
    static var intimidation: Sort {
        get {
            return .init(nom: "Intimidation", recharges: 2, defenseEnnemieDiminuee: 1)
        }
    }
    
    
}
